Plugin.extend({
    target: '',
    _data: undefined,
    buttons: [],
    _testis: undefined,
    _type: 'keyboard',
    _isContainer: false,
    _render: true,
    _mainKeys: undefined,

    initPlugin: function(data) {

        _data = data;
        target = data.target;
        var customButtons;

        if (data.keys) {
            customButtons = this._stage.getModelValue(data.keys);
        }
        _mainKeys = customButtons;
        this.createKeyboard(customButtons, data);
    },

    createKeyboard: function(customButtons, data) {
        var asset = data.asset;
        var dims = this.relativeDims();
        

        var parentDiv = document.getElementById(Renderer.divIds.gameArea);

        keyboardMainKeysParentDiv = document.createElement('div');
        keyboardMainKeysParentDiv.id = "parentDivMainKeyboard";

        if (data.type == "custom") {
            customButtons = customButtons.replace(/ /g, '');
            customButtons = customButtons.split(',');
            customButtons = _.uniq(customButtons);
            var buttons = customButtons.splice(0, 26);
            var keyHeight;
            var keyWidth;

            var specialKeyButtons = ["123", " ", ",", "."];

            var firstRowdiv = document.createElement('div');
            firstRowdiv.id = "firstRow";

            var secondRowdiv = document.createElement('div');
            secondRowdiv.id = "secondRow";

            var thirdRowdiv = document.createElement('div');
            thirdRowdiv.id = "thirdRow";

            var fontSize = 3.0;
            var customKeys = '';
            var keysForFirstRow = '';
            var keysForSecondRow = '';
            var keysForThirdRow = '';
            var eachRowLength = parseInt(buttons.length / 2);

            var languageImageSrc = Renderer.theme._data.manifest.media.find(function(o) {
                return o.id == 'languageIcon'
            });

            for (var i = 0; i < buttons.length; i++) {

                if (i < eachRowLength) {
                    keysForFirstRow += '<div class="key_barakhadi" id="' + buttons[i] + '_btn" style="width: ' + keyWidth + 'px"><span>' + buttons[i] + '</span></div>';
                } else {
                    keysForSecondRow += '<div class="key_barakhadi" id="' + buttons[i] + '_btn" style="width: ' + keyWidth + 'px"><span>' + buttons[i] + '</span></div>';
                }
            }

            for (var i = 0; i < specialKeyButtons.length; i++) {
                var keyWidth = "41";

                if (specialKeyButtons[i] == " ") {
                    keysForThirdRow += '<div class="spaceBar" style=" font-size:' + fontSize + 'vw;" id="' + specialKeyButtons[i] + 'MK_btn"><span>' + specialKeyButtons[i] + '</span></div>';
                } else {
                    keysForThirdRow += '<div class="speacial_keys" id="' + specialKeyButtons[i] + 'MK_btn"><span>' + specialKeyButtons[i] + '</span></div>';
                }
            }
            firstRowdiv.innerHTML = '' + keysForFirstRow + '';
            secondRowdiv.innerHTML = '' + keysForSecondRow + '';
            thirdRowdiv.innerHTML = '' + keysForThirdRow + '';
        }
        keyboardMainKeysParentDiv.appendChild(firstRowdiv);
        keyboardMainKeysParentDiv.appendChild(secondRowdiv);
        keyboardMainKeysParentDiv.appendChild(thirdRowdiv);

        parentDiv.appendChild(keyboardMainKeysParentDiv);

        /*var elmnt = document.getElementById("firstRow");
        var divWidth = elmnt.offsetWidth;*/
        var parentDivWidth = parentDiv.parentElement.offsetWidth;
        var divWidth = 0.8 * parentDivWidth;
        console.log("main parent div width:", parentDivWidth);
        console.log("main key div width:", divWidth);
        var keyWidth = (divWidth / (buttons.length - eachRowLength)) - 2;
        $(".key_barakhadi").css('width', keyWidth);
        $("#123MK_btn").css('font-size', '2vw');
        if(buttons.length <= 10) {
            $("#parentDivMainKeyboard > #secondRow").css('left', '-7%');
        }
        for (var i = buttons.length - 1; i >= 0; i--) {
            this.assignButtonEvent(buttons[i], asset, data.limit);
        };

        for (var i = specialKeyButtons.length - 1; i >= 0; i--) {
            this.assignButtonEvent(specialKeyButtons[i] + "MK", asset, data.limit);
        };

        /*Numeric Keyboard*/

        keyboardNumericKeysParentDiv = document.createElement('div');
        keyboardNumericKeysParentDiv.id = "parentDivNumericKeyboard";

        customButtons = "1,2,3,4,5,6,7,8,9,0,@,?,!,%,&,*,(,),+,-,÷,×,=";

        if (data.type == "custom") {
            customButtons = customButtons.replace(/ /g, '');
            customButtons = customButtons.split(',');
            customButtons = _.uniq(customButtons);
            var buttons = customButtons.splice(0, 26);
            var keyHeight;
            var keyWidth;

            var specialKeyButtons = ["<", ">", " ", ",", "."];

            var firstRowdiv = document.createElement('div');
            firstRowdiv.id = "firstRow";

            var secondRowdiv = document.createElement('div');
            secondRowdiv.id = "secondRow";

            var thirdRowdiv = document.createElement('div');
            thirdRowdiv.id = "thirdRow";

            var fontSize = 3.0;
            var customKeys = '';
            var keysForFirstRow = '';
            var keysForSecondRow = '';
            var keysForThirdRow = '';
            var eachRowLength = parseInt(buttons.length / 2);

            var languageImageSrc = Renderer.theme._data.manifest.media.find(function(o) {
                return o.id == 'languageIcon'
            });

            for (var i = 0; i < buttons.length; i++) {

                if (i < eachRowLength) {
                    keysForFirstRow += '<div class="key_barakhadi_numeric" id="' + buttons[i] + '_btn" style="width: ' + keyWidth + 'px"><span>' + buttons[i] + '</span></div>';
                } else {
                    keysForSecondRow += '<div class="key_barakhadi_numeric" id="' + buttons[i] + '_btn" style="width: ' + keyWidth + 'px"><span>' + buttons[i] + '</span></div>';
                }
            }

            for (var i = 0; i < specialKeyButtons.length; i++) {
                var keyWidth = "41";

                if (specialKeyButtons[i] == " ") {
                    keysForThirdRow += '<div id="languageIconDiv"><img id="languageIconImage" src=" ' + languageImageSrc.src + ' ">' + specialKeyButtons[i] + '</img></div>';
                    keysForThirdRow += '<div class="spaceBar" style=" font-size:' + fontSize + 'vw;" id="' + specialKeyButtons[i] + '_btn"><span>' + specialKeyButtons[i] + '</span></div>';
                } else {
                    keysForThirdRow += '<div class="speacial_keys" id="' + specialKeyButtons[i] + '_btn"><span>' + specialKeyButtons[i] + '</span></div>';
                }
            }
            firstRowdiv.innerHTML = '' + keysForFirstRow + '';
            secondRowdiv.innerHTML = '' + keysForSecondRow + '';
            thirdRowdiv.innerHTML = '' + keysForThirdRow + '';
        }

        keyboardNumericKeysParentDiv.appendChild(firstRowdiv);
        keyboardNumericKeysParentDiv.appendChild(secondRowdiv);
        keyboardNumericKeysParentDiv.appendChild(thirdRowdiv);

        parentDiv.appendChild(keyboardNumericKeysParentDiv);

        /*var elmnt = document.getElementById("firstRow");*/
        // var divWidth = elmnt.offsetWidth;
        var parentDivWidth = parentDiv.parentElement.offsetWidth;
        var divWidth = 0.8 * parentDivWidth;
        console.log("numeric parent div width:", parentDivWidth);
        console.log("numeric key div width:", divWidth);
        /*console.log($('#gameCanvas').offsetWidth);*/
        var keyWidth = (divWidth / (buttons.length - eachRowLength)) - 2;
        $(".key_barakhadi_numeric").css('width', keyWidth);

        $("#parentDivNumericKeyboard").hide();

        $("#languageIconDiv").click(function() {
            $("#parentDivMainKeyboard").show();
            $("#parentDivNumericKeyboard").hide();
        });

        $("#123MK_btn").click(function() {
            $("#parentDivMainKeyboard").hide();
            $("#parentDivNumericKeyboard").show();
        });

        for (var i = buttons.length - 1; i >= 0; i--) {
            this.assignButtonEvent(buttons[i], asset, data.limit);
        };
        for (var i = specialKeyButtons.length - 1; i >= 0; i--) {
            this.assignButtonEvent(specialKeyButtons[i], asset, data.limit);
        };
    },

    switchTarget: function(action) {
        target = action.id;
    },

    assignButtonEvent: function(id, asset, limit) {

        var btn = document.getElementById(id + '_btn');

        var instance = this;

        if (btn != null) {

            btn.addEventListener("click", function() {

                var newText = PluginManager.getPluginObject(target);

                if (newText._self.text.length + id.length <= limit) {
                    if (id != "123MK") {
                        if (id.endsWith("MK") == true) {
                            var newId = id.slice(0, -2);
                            newText._self.text += newId;
                        } else {
                            newText._self.text += id;
                        }
                    }
                }

                Renderer.update = true;
                instance._stage.setModelValue(newText._data.model, newText._self.text)
            });
        }
    }
});

//# sourceURL=customKeyboardAdvanced.js